#!/usr/bin/perl -w
#
# Author: Lulin Song 2005
#
# $Id: makefileGenerator.pl,v 1.7 2006/02/22 21:04:19 lsong Exp $
#
# To create a Makefile for c program generated by DriverGenerator.pl
# file
#
# Usage:
#
# makefileGenerator.pl c_program_name makeFileNameWithFullPath libName MCRFileDir NetcdfDir
#
# eg.
#
# makefileGenerator.pl knnAnalogModel Makefile libswg /home/lsong/v73 NO
#

if( $#ARGV < 3 )
{
   print <<EOF;
Usage: $0 c_program_name makeFileNameWithFullPath libName MCRFileDir NetcdfDir
eg.
$0 knnAnalogModel knnAnalogModel.makefile libswg /home/lsong/v73 NO
    or
$0 knnAnalogModel knnAnalogModel.makefile libswg /home/lsong/v73 /software/rhel/i386/netcdf-3.5.1 
EOF
   exit(0);
}

($programName,$makeFileName,$libName, $mcrPath, $netcdfPath) = @ARGV;

open($fd,">$makeFileName") or die "Can't open $makeFileName: $!\n";
$when = "Generated: ".gmtime();
$what = "Makefile to build ".$programName;
$libName =~ s/^(lib)//;

print $fd "
# Do not edit. Automatically generated by makefileGenerator.pl script
#
# Author: Lulin Song (International Research Institute for Climate Society)
#
# $when (GMT).
# $what program which using UNIX style command line arguments.
#
";

open($INFILE,'makefile.template') or die "Can't open makefile.template: $!\n";
while( $line=<$INFILE> ) {
  $line =~ s/PROGRAM/${programName}/g;
  $line =~ s/LIBNAME/$libName/g;
  if( $line =~ /^(MCR_ROOT)/ )
  {print $line; chop ($line); $line .= $mcrPath."\n"; }
  if($netcdfPath !~ /^(NO)$/)
  {
    if( $line =~ /^(INCLUDES)/ )
    { chop ($line); $line .= " -I".$netcdfPath."/include\n"; }
    if( $line =~ /^(SYSLIBS)/ )
    { chop ($line); $line .= " -L".$netcdfPath."/lib -lnetcdf\n"; }
    if( $line =~ /^(SRCS)/ )
    { chop ($line); $line .= " netcdfRW.c\n"; }
  }
print $fd $line;
}
close($INFILE);
close($fd);
