#!/usr/bin/perl -w
#
# Author: Lulin Song 2006
#
# $Id: mpg.pl,v 1.6 2006/02/22 21:04:19 lsong Exp $
#
# To create a stand alone c program
#
# Usage:
#
# mpg.pl c_program_name libname parameterFileName MCRDir netcdfDir
#
# eg.
#
# mpg.pl knnAnalogModel libswg knnAnalogModel.input /home/lsong/v73 /software/rhel/i386/netcdf-3.5.1/
#

if( $#ARGV < 2 )
{
   print <<EOF;
Usage: $0 c_program_name libName  parameterFileName MCRDir netcdfDir
eg.
$0 knnAnalogModel libswg knn_analog.input /home/lsong/v73 /software/rhel/i386/netcdf-3.5.1/
    or if you don't need netcdf support,
$0 knnAnalogModel libswg knn_analog.input /home/lsong/v73 NO 

EOF
   exit(0);
}

($programName,$libName,$paramFile, $mcrDir, $netcdfPath) = @ARGV;

$CfileName = $programName.".c";
(system ("./DriverGenerator.pl $paramFile $CfileName $libName")==0) or die "Failed to create $CfileName";
$outMakefile = $programName.".makefile";
(system ("./makefileGenerator.pl $programName $outMakefile $libName $mcrDir $netcdfPath")==0) or die "Failed to create $outMakefile";
(system (" gmake -f $outMakefile clean") ==0) or die "Failed to clean.\n";
(system (" gmake -f $outMakefile ")==0) or die "Failed to create program $programName";

#Create executable script
$exportStr="export";
open (FD," >$programName") or die "Cant' open $programName: $!\n:";
print FD <<EOF;
\#\!/bin/bash
env -i
$exportStr MCR_ROOT=\"$mcrDir\"
$exportStr LD_LIBRARY_PATH=\"\${MCR_ROOT}/bin/glnx86:\${MCR_ROOT}/runtime/glnx86:\${MCR_ROOT}/sys/os/glnx86:\${MCR_ROOT}/sys/java/jre/glnx86/jre1.5.0/lib/i386/native_threads:\${MCR_ROOT}/sys/java/jre/glnx86/jre1.5.0/lib/i386/client:\${MCR_ROOT}/sys/java/jre/glnx86/jre1.5.0/lib/i386:./\"
$exportStr XAPPLRESDIR="/software/rhel/i386/matlabR14SP3/x11"
./$programName.x \$\@
EOF

(system (" chmod a+x $programName")==0) or die "Failed to chomd $programName";

close(FD);
